/*
 * uart.h
 *
 *  Created on: 01-Apr-2024
 *      Author: DELL-2
 */

#ifndef UART_H_
#define UART_H_


#define VBOOT_ENTRY_CMD     0xAA
#define VBOOT_VERSION       0xA1

#define BSL_VERSION_CMD     0x19
#define BSL_ERASE_APP_CMD   0x15
#define BSL_RX_APP_CMD      0x10
#define BSL_JMP_APP_CMD     0x1C

#define BSL_OK_RES          0x00

#define BSL_HEADER          0x80

typedef struct sBSLPayload
{
    uint8_t ui8Command;
    uint8_t ui8Addr_L;
    uint8_t ui8Addr_M;
    uint8_t ui8Addr_H;
    const uint8_t* ui8pData;
} tBSLPayload;

typedef struct sBSLPacket
{
    uint8_t ui8Header;
    uint8_t ui8Length;
    tBSLPayload tPayload;
    uint16_t ui16Checksum;
} tBSLPacket;


extern char received_responseFlag;

extern void BSL_sendSingleByte(uint8_t ui8Byte);
extern uint8_t BSL_sendCommand(uint8_t cmd);
extern void BSL_sendPacket(tBSLPacket tPacket);

extern uint16_t crc16MakeBitwise(tBSLPacket tPacket);
extern uint8_t BSL_getResponse(void);

extern uint8_t BSL_programMemorySegment(uint32_t addr, const uint8_t* data,
                                        uint32_t len);
#endif /* UART_H_ */
